# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 4.6.0-SNAPSHOT
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus_client.com.termlex.pathnexus.model.canonical_type import CanonicalType  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.coding import Coding  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.extension import Extension  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.id_type import IdType  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.instant_type import InstantType  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.string_type import StringType  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.uri_type import UriType  # noqa: F401,E501


class Meta(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'format_comments_pre': 'list[str]',
        'format_comments_post': 'list[str]',
        'id': 'str',
        'extension': 'list[Extension]',
        'disallow_extensions': 'bool',
        'version_id': 'str',
        'last_updated': 'datetime',
        'source': 'str',
        'profile': 'list[CanonicalType]',
        'security': 'list[Coding]',
        'tag': 'list[Coding]',
        'version_id_element': 'IdType',
        'last_updated_element': 'InstantType',
        'source_element': 'UriType',
        'security_first_rep': 'Coding',
        'tag_first_rep': 'Coding',
        'empty': 'bool',
        'extension_first_rep': 'Extension',
        'id_element': 'StringType',
        'id_base': 'str',
        'primitive': 'bool',
        'resource': 'bool',
        'boolean_primitive': 'bool',
        'date_time': 'bool'
    }

    attribute_map = {
        'format_comments_pre': 'formatCommentsPre',
        'format_comments_post': 'formatCommentsPost',
        'id': 'id',
        'extension': 'extension',
        'disallow_extensions': 'disallowExtensions',
        'version_id': 'versionId',
        'last_updated': 'lastUpdated',
        'source': 'source',
        'profile': 'profile',
        'security': 'security',
        'tag': 'tag',
        'version_id_element': 'versionIdElement',
        'last_updated_element': 'lastUpdatedElement',
        'source_element': 'sourceElement',
        'security_first_rep': 'securityFirstRep',
        'tag_first_rep': 'tagFirstRep',
        'empty': 'empty',
        'extension_first_rep': 'extensionFirstRep',
        'id_element': 'idElement',
        'id_base': 'idBase',
        'primitive': 'primitive',
        'resource': 'resource',
        'boolean_primitive': 'booleanPrimitive',
        'date_time': 'dateTime'
    }

    def __init__(self, format_comments_pre=None, format_comments_post=None, id=None, extension=None, disallow_extensions=None, version_id=None, last_updated=None, source=None, profile=None, security=None, tag=None, version_id_element=None, last_updated_element=None, source_element=None, security_first_rep=None, tag_first_rep=None, empty=None, extension_first_rep=None, id_element=None, id_base=None, primitive=None, resource=None, boolean_primitive=None, date_time=None):  # noqa: E501
        """Meta - a model defined in Swagger"""  # noqa: E501

        self._format_comments_pre = None
        self._format_comments_post = None
        self._id = None
        self._extension = None
        self._disallow_extensions = None
        self._version_id = None
        self._last_updated = None
        self._source = None
        self._profile = None
        self._security = None
        self._tag = None
        self._version_id_element = None
        self._last_updated_element = None
        self._source_element = None
        self._security_first_rep = None
        self._tag_first_rep = None
        self._empty = None
        self._extension_first_rep = None
        self._id_element = None
        self._id_base = None
        self._primitive = None
        self._resource = None
        self._boolean_primitive = None
        self._date_time = None
        self.discriminator = None

        if format_comments_pre is not None:
            self.format_comments_pre = format_comments_pre
        if format_comments_post is not None:
            self.format_comments_post = format_comments_post
        if id is not None:
            self.id = id
        if extension is not None:
            self.extension = extension
        if disallow_extensions is not None:
            self.disallow_extensions = disallow_extensions
        if version_id is not None:
            self.version_id = version_id
        if last_updated is not None:
            self.last_updated = last_updated
        if source is not None:
            self.source = source
        if profile is not None:
            self.profile = profile
        if security is not None:
            self.security = security
        if tag is not None:
            self.tag = tag
        if version_id_element is not None:
            self.version_id_element = version_id_element
        if last_updated_element is not None:
            self.last_updated_element = last_updated_element
        if source_element is not None:
            self.source_element = source_element
        if security_first_rep is not None:
            self.security_first_rep = security_first_rep
        if tag_first_rep is not None:
            self.tag_first_rep = tag_first_rep
        if empty is not None:
            self.empty = empty
        if extension_first_rep is not None:
            self.extension_first_rep = extension_first_rep
        if id_element is not None:
            self.id_element = id_element
        if id_base is not None:
            self.id_base = id_base
        if primitive is not None:
            self.primitive = primitive
        if resource is not None:
            self.resource = resource
        if boolean_primitive is not None:
            self.boolean_primitive = boolean_primitive
        if date_time is not None:
            self.date_time = date_time

    @property
    def format_comments_pre(self):
        """Gets the format_comments_pre of this Meta.  # noqa: E501


        :return: The format_comments_pre of this Meta.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_pre

    @format_comments_pre.setter
    def format_comments_pre(self, format_comments_pre):
        """Sets the format_comments_pre of this Meta.


        :param format_comments_pre: The format_comments_pre of this Meta.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_pre = format_comments_pre

    @property
    def format_comments_post(self):
        """Gets the format_comments_post of this Meta.  # noqa: E501


        :return: The format_comments_post of this Meta.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_post

    @format_comments_post.setter
    def format_comments_post(self, format_comments_post):
        """Sets the format_comments_post of this Meta.


        :param format_comments_post: The format_comments_post of this Meta.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_post = format_comments_post

    @property
    def id(self):
        """Gets the id of this Meta.  # noqa: E501


        :return: The id of this Meta.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Meta.


        :param id: The id of this Meta.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def extension(self):
        """Gets the extension of this Meta.  # noqa: E501


        :return: The extension of this Meta.  # noqa: E501
        :rtype: list[Extension]
        """
        return self._extension

    @extension.setter
    def extension(self, extension):
        """Sets the extension of this Meta.


        :param extension: The extension of this Meta.  # noqa: E501
        :type: list[Extension]
        """

        self._extension = extension

    @property
    def disallow_extensions(self):
        """Gets the disallow_extensions of this Meta.  # noqa: E501


        :return: The disallow_extensions of this Meta.  # noqa: E501
        :rtype: bool
        """
        return self._disallow_extensions

    @disallow_extensions.setter
    def disallow_extensions(self, disallow_extensions):
        """Sets the disallow_extensions of this Meta.


        :param disallow_extensions: The disallow_extensions of this Meta.  # noqa: E501
        :type: bool
        """

        self._disallow_extensions = disallow_extensions

    @property
    def version_id(self):
        """Gets the version_id of this Meta.  # noqa: E501


        :return: The version_id of this Meta.  # noqa: E501
        :rtype: str
        """
        return self._version_id

    @version_id.setter
    def version_id(self, version_id):
        """Sets the version_id of this Meta.


        :param version_id: The version_id of this Meta.  # noqa: E501
        :type: str
        """

        self._version_id = version_id

    @property
    def last_updated(self):
        """Gets the last_updated of this Meta.  # noqa: E501


        :return: The last_updated of this Meta.  # noqa: E501
        :rtype: datetime
        """
        return self._last_updated

    @last_updated.setter
    def last_updated(self, last_updated):
        """Sets the last_updated of this Meta.


        :param last_updated: The last_updated of this Meta.  # noqa: E501
        :type: datetime
        """

        self._last_updated = last_updated

    @property
    def source(self):
        """Gets the source of this Meta.  # noqa: E501


        :return: The source of this Meta.  # noqa: E501
        :rtype: str
        """
        return self._source

    @source.setter
    def source(self, source):
        """Sets the source of this Meta.


        :param source: The source of this Meta.  # noqa: E501
        :type: str
        """

        self._source = source

    @property
    def profile(self):
        """Gets the profile of this Meta.  # noqa: E501


        :return: The profile of this Meta.  # noqa: E501
        :rtype: list[CanonicalType]
        """
        return self._profile

    @profile.setter
    def profile(self, profile):
        """Sets the profile of this Meta.


        :param profile: The profile of this Meta.  # noqa: E501
        :type: list[CanonicalType]
        """

        self._profile = profile

    @property
    def security(self):
        """Gets the security of this Meta.  # noqa: E501


        :return: The security of this Meta.  # noqa: E501
        :rtype: list[Coding]
        """
        return self._security

    @security.setter
    def security(self, security):
        """Sets the security of this Meta.


        :param security: The security of this Meta.  # noqa: E501
        :type: list[Coding]
        """

        self._security = security

    @property
    def tag(self):
        """Gets the tag of this Meta.  # noqa: E501


        :return: The tag of this Meta.  # noqa: E501
        :rtype: list[Coding]
        """
        return self._tag

    @tag.setter
    def tag(self, tag):
        """Sets the tag of this Meta.


        :param tag: The tag of this Meta.  # noqa: E501
        :type: list[Coding]
        """

        self._tag = tag

    @property
    def version_id_element(self):
        """Gets the version_id_element of this Meta.  # noqa: E501


        :return: The version_id_element of this Meta.  # noqa: E501
        :rtype: IdType
        """
        return self._version_id_element

    @version_id_element.setter
    def version_id_element(self, version_id_element):
        """Sets the version_id_element of this Meta.


        :param version_id_element: The version_id_element of this Meta.  # noqa: E501
        :type: IdType
        """

        self._version_id_element = version_id_element

    @property
    def last_updated_element(self):
        """Gets the last_updated_element of this Meta.  # noqa: E501


        :return: The last_updated_element of this Meta.  # noqa: E501
        :rtype: InstantType
        """
        return self._last_updated_element

    @last_updated_element.setter
    def last_updated_element(self, last_updated_element):
        """Sets the last_updated_element of this Meta.


        :param last_updated_element: The last_updated_element of this Meta.  # noqa: E501
        :type: InstantType
        """

        self._last_updated_element = last_updated_element

    @property
    def source_element(self):
        """Gets the source_element of this Meta.  # noqa: E501


        :return: The source_element of this Meta.  # noqa: E501
        :rtype: UriType
        """
        return self._source_element

    @source_element.setter
    def source_element(self, source_element):
        """Sets the source_element of this Meta.


        :param source_element: The source_element of this Meta.  # noqa: E501
        :type: UriType
        """

        self._source_element = source_element

    @property
    def security_first_rep(self):
        """Gets the security_first_rep of this Meta.  # noqa: E501


        :return: The security_first_rep of this Meta.  # noqa: E501
        :rtype: Coding
        """
        return self._security_first_rep

    @security_first_rep.setter
    def security_first_rep(self, security_first_rep):
        """Sets the security_first_rep of this Meta.


        :param security_first_rep: The security_first_rep of this Meta.  # noqa: E501
        :type: Coding
        """

        self._security_first_rep = security_first_rep

    @property
    def tag_first_rep(self):
        """Gets the tag_first_rep of this Meta.  # noqa: E501


        :return: The tag_first_rep of this Meta.  # noqa: E501
        :rtype: Coding
        """
        return self._tag_first_rep

    @tag_first_rep.setter
    def tag_first_rep(self, tag_first_rep):
        """Sets the tag_first_rep of this Meta.


        :param tag_first_rep: The tag_first_rep of this Meta.  # noqa: E501
        :type: Coding
        """

        self._tag_first_rep = tag_first_rep

    @property
    def empty(self):
        """Gets the empty of this Meta.  # noqa: E501


        :return: The empty of this Meta.  # noqa: E501
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """Sets the empty of this Meta.


        :param empty: The empty of this Meta.  # noqa: E501
        :type: bool
        """

        self._empty = empty

    @property
    def extension_first_rep(self):
        """Gets the extension_first_rep of this Meta.  # noqa: E501


        :return: The extension_first_rep of this Meta.  # noqa: E501
        :rtype: Extension
        """
        return self._extension_first_rep

    @extension_first_rep.setter
    def extension_first_rep(self, extension_first_rep):
        """Sets the extension_first_rep of this Meta.


        :param extension_first_rep: The extension_first_rep of this Meta.  # noqa: E501
        :type: Extension
        """

        self._extension_first_rep = extension_first_rep

    @property
    def id_element(self):
        """Gets the id_element of this Meta.  # noqa: E501


        :return: The id_element of this Meta.  # noqa: E501
        :rtype: StringType
        """
        return self._id_element

    @id_element.setter
    def id_element(self, id_element):
        """Sets the id_element of this Meta.


        :param id_element: The id_element of this Meta.  # noqa: E501
        :type: StringType
        """

        self._id_element = id_element

    @property
    def id_base(self):
        """Gets the id_base of this Meta.  # noqa: E501


        :return: The id_base of this Meta.  # noqa: E501
        :rtype: str
        """
        return self._id_base

    @id_base.setter
    def id_base(self, id_base):
        """Sets the id_base of this Meta.


        :param id_base: The id_base of this Meta.  # noqa: E501
        :type: str
        """

        self._id_base = id_base

    @property
    def primitive(self):
        """Gets the primitive of this Meta.  # noqa: E501


        :return: The primitive of this Meta.  # noqa: E501
        :rtype: bool
        """
        return self._primitive

    @primitive.setter
    def primitive(self, primitive):
        """Sets the primitive of this Meta.


        :param primitive: The primitive of this Meta.  # noqa: E501
        :type: bool
        """

        self._primitive = primitive

    @property
    def resource(self):
        """Gets the resource of this Meta.  # noqa: E501


        :return: The resource of this Meta.  # noqa: E501
        :rtype: bool
        """
        return self._resource

    @resource.setter
    def resource(self, resource):
        """Sets the resource of this Meta.


        :param resource: The resource of this Meta.  # noqa: E501
        :type: bool
        """

        self._resource = resource

    @property
    def boolean_primitive(self):
        """Gets the boolean_primitive of this Meta.  # noqa: E501


        :return: The boolean_primitive of this Meta.  # noqa: E501
        :rtype: bool
        """
        return self._boolean_primitive

    @boolean_primitive.setter
    def boolean_primitive(self, boolean_primitive):
        """Sets the boolean_primitive of this Meta.


        :param boolean_primitive: The boolean_primitive of this Meta.  # noqa: E501
        :type: bool
        """

        self._boolean_primitive = boolean_primitive

    @property
    def date_time(self):
        """Gets the date_time of this Meta.  # noqa: E501


        :return: The date_time of this Meta.  # noqa: E501
        :rtype: bool
        """
        return self._date_time

    @date_time.setter
    def date_time(self, date_time):
        """Sets the date_time of this Meta.


        :param date_time: The date_time of this Meta.  # noqa: E501
        :type: bool
        """

        self._date_time = date_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Meta):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
